#!/bin/sh

DRIVER=arcsas

echo "Driver Installation"

MACHINE=`uname -m`
KERNEL=`uname -r`
export PATH=/bin:/sbin:/usr/bin:/usr/sbin
mkdir /tmp/modules
cd /tmp/modules
tar xvf /tmp/arcsas/modules.tar

for ver in /lib/modules/*; do
	kver=`basename $ver`
	if [ -d /lib/modules/${kver} -a -d /tmp/modules/${kver} ]; then
		echo "Updating ${kver}..."
		mkdir -p /lib/modules/${kver}/kernel/drivers/scsi/${DRIVER} &&
		cp -f /tmp/modules/${kver}/${MACHINE}/${DRIVER}.ko /lib/modules/${kver}/kernel/drivers/scsi/${DRIVER}/ &&
		echo 'arcsas' >> /etc/initramfs-tools/modules &&
		echo 'blacklist mvsas' >> /etc/modprobe.d/blacklist.local.conf &&
		/sbin/depmod -a ${kver}

		if [ $? = 1 ]; then
			echo "Postinstall 1 failed! Copy driver failed!"
			exit
		fi

		rm -rf /dev/null
		update-initramfs -u -k ${kver}

		if [ $? = 1 ]; then
			echo "Postinstall 2 failed! Update initramfs failed!"
			exit
		fi
	fi
done

rm -fr /tmp/modules
sync;sync;sync
echo "Driver Installation Step 2 Completed."
